/** ComposantsCat.java */
package fournisseurs;

import parcInfo.Composants;
import parcInfo.Equipement;

@SuppressWarnings("serial")


abstract public class ComposantsCat extends Produits
{
	private boolean venduAuDetail;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 */
	public ComposantsCat(String marque, float prix, String reference, String type, boolean venduAuDetail) {
		super(marque, prix, reference, type);
		this.venduAuDetail = venduAuDetail;
	}
	
	
	/**
	 * @return vrai si le composant est vendu Au Detail
	 */
	public boolean isVenduAuDetail() {
		return venduAuDetail;
	}
	
	
	/**
	 * @param venduAuDetail initialisation de la variable venduAuDetail
	 */
	public void setVenduAuDetail(boolean venduAuDetail) {
		this.venduAuDetail = venduAuDetail;
	}
	
	
	
	/**
	 * @return String : Description du composant
	 */
	public String toString()
	{
		String chaine="Composant ";
		
		if(venduAuDetail)
			chaine=chaine +"vendu au detail";
		return chaine+"\n marque "+super.getMarque()+" prix "+super.getPrix()+" type "+super.getType()+" reference "+super.getReference()+"\n"; 
	}
	
	/**
	 * Methodes Abstraites pour comparer un equipement ou un composant a un composant
	 */
	public abstract boolean egalOuSuperieur(Composants c, boolean VenteAuDetail);
	public abstract boolean egalOuSuperieur(Equipement c);
}
