/** DisqueDurCat.java */
package fournisseurs;
import parcInfo.*;
@SuppressWarnings("serial")
public class DisqueDurCat extends PeripheriqueCat
{
    private float capacite;

	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param vitesse
	 * @param estExterne
	 * @param capacite
	 */
	public DisqueDurCat(String marque, float prix, String reference, String type, boolean venduAuDetail, float vitesse, boolean estExterne, float capacite) {
		super(marque, prix, reference, type, venduAuDetail, vitesse, estExterne);
		this.capacite = capacite;
	}

	/**
	 * @return la capacite du Disque Dur
	 */
	public float getCapacite() {
		return capacite;
	}

	/**
	 * @param capacite initialise la capacite
	 */
	public void setCapacite(float capacite) {
		this.capacite = capacite;
	}
		
    /**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.PeripheriqueCat#toString()
	 */
    public String toString()
    {
	return "Disque dur \n"+super.toString()+" Capacite : "+capacite + " Go\n";
    }

	/**
	 * On compare ici si un Disque Dur est egal ou superieur a celui passe en parametre
	 * On considere qu'un Disque Dur est egal ou superieur a un autre si il   
	 * a une capacite superieure ou egale
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.PeripheriqueCat#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
    public boolean egalOuSuperieur(Composants c,boolean VenteAuDetail)
    {
	if (c instanceof DisqueDur && VenteAuDetail==this.isVenduAuDetail() && this.getCapacite()>=((DisqueDur)c).getCapacite() && this.isEstExterne()==((DisqueDur)c).isEstExterne() && this.getVitesse()>=((DisqueDur)c).getVitesse())
	    return true;
	return false;
    }

    /**
     * @param e Equipement : l'equipement a tester
     * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
     * @see fournisseurs.PeripheriqueCat#egalOuSuperieur(parcInfo.Equipement)
     */
    public boolean egalOuSuperieur(Equipement e)
    {
    	return false;
    }
}
