/** Classe Abstraite PeripheriqueCat.java */
package fournisseurs;
import parcInfo.*;

@SuppressWarnings("serial")
abstract public class PeripheriqueCat extends ComposantsCat
{
	private float vitesse;
	private boolean estExterne;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param vitesse
	 * @param estExterne
	 */
	public PeripheriqueCat(String marque, float prix, String reference, String type, boolean venduAuDetail, float vitesse, boolean estExterne) {
		super(marque, prix, reference, type, venduAuDetail);
		this.vitesse = vitesse;
		this.estExterne = estExterne;
	}
	
	/**
	 * @return vrai si le peripherique est Externe
	 */
	public boolean isEstExterne() {
		return estExterne;
	}
	
	/**
	 * @param estExterne initialise la variable estExterne
	 */
	public void setEstExterne(boolean estExterne) {
		this.estExterne = estExterne;
	}
	
	/**
	 * @return la vitesse
	 */
	public float getVitesse() {
		return vitesse;
	}
	
	/**
	 * @param vitesse initialise la vitesse
	 */
	public void setVitesse(float vitesse) {
		this.vitesse = vitesse;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
	{
		String chaine;
		
		if(estExterne)
			chaine="Peripherique Externe : ";
		else 
			chaine="Peripherique Interne : ";
		return chaine +"\n"+super.toString()+" Vitesse :" +this.vitesse;
	}
	
	/**
	 * Methodes Abstraites pour comparer un equipement ou un composant a un du catalogue
	 */
	public abstract boolean egalOuSuperieur(Composants c, boolean VenteAuDetail);
	public abstract boolean egalOuSuperieur(Equipement c);
}
