/** UcCat.java */
package fournisseurs;
import parcInfo.*;

@SuppressWarnings("serial")
public class UcCat extends ComposantsCat
{
	private float frequenceProcesseur;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param frequenceProcesseur
	 */
	public UcCat(String marque, float prix, String reference, String type, boolean venduAuDetail, float frequenceProcesseur) {
		super(marque, prix, reference, type, venduAuDetail);
		this.frequenceProcesseur = frequenceProcesseur;
	}
	
	/**
	 * @return la frequence du Processeur
	 */
	public float getFrequenceProcesseur() {
		return frequenceProcesseur;
	}
	
	/**
	 * @param frequenceProcesseur  initialise la variable frequenceProcesseur
	 */
	public void setFrequenceProcesseur(float frequenceProcesseur) {
		this.frequenceProcesseur = frequenceProcesseur;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
	{
		return "Unite centrale :\n" +super.toString()+ "Frequence : "+this.frequenceProcesseur+" GHz\n";
	}
	
	/**
	 * On compare ici si une uc est superieure ou egale a l'uc passee en parametre
	 * On considere qu'une uc est superieure ou egale a une autre si elle a une frequence  
	 * egale ou plus elevee
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
	public boolean egalOuSuperieur(Composants c, boolean VenteAuDetail)
	{
		if (c instanceof UC && VenteAuDetail==this.isVenduAuDetail() && this.getFrequenceProcesseur()>=((UC)c).getFrequenceProcesseur())
			return true;
		return false;
	}
	
	/**
	 * @param e Equipement : l'equipement a tester
	 * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
	 */
	public boolean egalOuSuperieur(Equipement e)
	{
		return false;
	}
}
