package graphique;
import java.util.TreeMap;
import parcInfo.*;
import javax.swing.*;

/**
 *
 * @author  ocremetz
 */
@SuppressWarnings("serial")

public class PanelListerEquipements extends JPanel {
	private Parc parcTest;
	private JScrollPane ScrollPane;
	private JTable TableEquipement;
	private int nbConnexions;
	private int nbImpressions;
	
	
	
	public PanelListerEquipements(Parc parcTest) {
		this.parcTest=parcTest;
		nbConnexions=0;
		nbImpressions=0;
		initComponents();
	}
	
	
	private void initComponents() {
		
		
		
		setLayout(new java.awt.BorderLayout());
		
		
		
		TreeMap<String,Equipement> listeEquipement;
		try{
			
			listeEquipement=parcTest.getListeEquipement();
			
			if(listeEquipement==null)
				JOptionPane.showMessageDialog(null, "Liste Vide", "Erreur", JOptionPane.ERROR_MESSAGE);
			
			int tailleJTable=listeEquipement.size()+2;
			
			
			Object [][] jTableRemplie=new Object [tailleJTable][6]; 
			int i=0;
			
			Equipement e;
			for (String code:listeEquipement.keySet())
			{
				e=listeEquipement.get(code) ;
				
				if (e!=null){
					if (e instanceof Ordinateur)
					{
						jTableRemplie[i][0]=(String)("Ordinateur");
						
						if (((Ordinateur)e).CalculerEtatOrdinateur())
							jTableRemplie[i][4]="Defectueux";
						else
							jTableRemplie[i][4]="Non Defectueux";
						nbConnexions+=((Ordinateur)e).getNbConnexions();
						jTableRemplie[i][5]=((Ordinateur)e).getNbConnexions();
					}
					if(e instanceof Imprimante)
					{
						
						jTableRemplie[i][0]=(String)("Imprimante");
						if (((Imprimante)e).isEtat())
							jTableRemplie[i][4]="Defectueux";
						else
							jTableRemplie[i][4]="Non Defectueux";
						
						nbImpressions+=((Imprimante)e).getNbPagesImprimees();
						jTableRemplie[i][5]=((Imprimante)e).getNbPagesImprimees();
					}
					
					jTableRemplie[i][1]=e.getNom();
					jTableRemplie[i][2]=e.getMarque();
					jTableRemplie[i][3]=e.getType();
					
					i++;	
				}
				jTableRemplie[tailleJTable-1][1]="Nb de Connexions";
				jTableRemplie[tailleJTable-1][2]=nbConnexions;
				jTableRemplie[tailleJTable-1][4]="Nb d'Impressions";
				jTableRemplie[tailleJTable-1][5]=nbImpressions;
				
				
				String []Titre={"Equipement", "Nom", "Marque", "Type","Etat","Nb Connexion/Impression"};
				TableEquipement = new JTable(jTableRemplie,Titre);
				
				
				TableEquipement.setAutoscrolls(true);
				
				
				ScrollPane = new JScrollPane(TableEquipement);
				this.add(ScrollPane);
				
				
				
			}
		}
		catch(NullPointerException e)
		{
			JOptionPane.showMessageDialog(null, "Erreur", "Erreur", JOptionPane.ERROR_MESSAGE);
		}
		
		
	}
	
}
