/** Imprimante.java */
package parcInfo;

@SuppressWarnings("serial")
public class Imprimante extends Equipement
{
	private int nbPagesImprimees;
	private boolean estUSB;
	private boolean estReseau;
	private boolean etat;
	
	/**
	 * @param nom
	 * @param marque
	 * @param type
	 * @param estUSB
	 * @param estReseau
	 */
	public Imprimante(String nom, String marque, String type, boolean estUSB, boolean estReseau) {
		super(nom, marque, type);
		this.nbPagesImprimees = 0;
		this.estUSB = estUSB;
		this.estReseau = estReseau;
		this.etat=false;
	}
	
	/**
	 * @return vrai si l'imprimante se branche sur un port Reseau
	 */
	public boolean isEstReseau() {
		return estReseau;
	}
	
	/**
	 * @param estReseau  initialise la variable estReseau
	 */
	public void setEstReseau(boolean estReseau) {
		this.estReseau = estReseau;
	}
	
	/**
	 * @return vrai si l'imprimante se branche sur un port USB
	 */
	public boolean isEstUSB() {
		return estUSB;
	}
	
	/**
	 * @param estUSB  initialise la variable estUSB
	 */
	public void setEstUSB(boolean estUSB) {
		this.estUSB = estUSB;
	}
	
	/**
	 * @return vrai si etat defectueux faux sinon
	 */
	public boolean isEtat() {
		return etat;
	}
	
	/**
	 * @param etat initialise la variable etat
	 */
	public void setEtat(boolean etat) {
		this.etat = etat;
	}
	
	/**
	 * @return le nb de Pages Imprimees
	 */
	public int getNbPagesImprimees() {
		return nbPagesImprimees;
	}
	
	/**
	 * @param nbPagesImprimees  initialise la variable nbPagesImprimees
	 */
	public void setNbPagesImprimees(int nbPagesImprimees) {
		this.nbPagesImprimees = nbPagesImprimees;
	}
	
	/**
	 * Incremente le nombre de pages imprimees avec la 
	 * valeur passee en parametre
	 * @param nbPagesImprimees : Nombre de pages imprimees
	 */
	public void incrementerImpression(int nbPagesImprimees) {
		this.nbPagesImprimees += nbPagesImprimees;
	}
	
	
	/**
	 * Retourne la description de l'imprimante
	 * @return String
	 */
	public String toString()
	{
		String chaine="\nImprimante";
		
		if(estReseau)
			chaine=chaine+" avec port Reseau";
		if(estUSB)
			chaine=chaine+" avec port USB";
		return chaine+super.toString();
	}
}


