/** Souris.java */
package parcInfo;

@SuppressWarnings("serial")
public class Souris extends Composants
{   
	private boolean estSansFil;
	private boolean avecMolette;
	
	/**
	 * @param nomComposant
	 * @param marqueComposant
	 * @param type
	 * @param estSansFil
	 * @param avecMolette
	 */
	public Souris(String nomComposant, String marqueComposant, String type, boolean estSansFil, boolean avecMolette) {
		super(nomComposant, marqueComposant, type);
		this.estSansFil = estSansFil;
		this.avecMolette = avecMolette;
	}
	
	/**
	 * @return vrai si la souris possede une Molette
	 */
	public boolean isAvecMolette() {
		return avecMolette;
	}
	
	/**
	 * @param avecMolette  initialise la variable avecMolette
	 */
	public void setAvecMolette(boolean avecMolette) {
		this.avecMolette = avecMolette;
	}
	
	/**
	 * @return vrai si la souris est Sans Fil
	 */
	public boolean isEstSansFil() {
		return estSansFil;
	}
	
	/**
	 * @param estSansFil  initialise la variable estSansFil
	 */
	public void setEstSansFil(boolean estSansFil) {
		this.estSansFil = estSansFil;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du composant
	 * @return String
	 * @see parcInfo.Composants#toString()
	 */
	public String toString()
	{
		String chaine="Souris ";
		if(estSansFil)
			chaine+="sans fil ";
		if(avecMolette)
			chaine+="avec molette ";
		return chaine +"\n"+super.toString();
	}
}
