import java.util.*;
import java.io.*;



import parcInfo.*;
import fournisseurs.*;

public class Appli {
	static Parc parc = new Parc("ParcTest");
	static Scanner in =new Scanner(System.in);
	
	
	
	public static boolean questionOuiNon(String question){
		
		System.out.println(question + "[oui/non] [par defaut:non]");
		String reponse=in.next();
		System.out.flush();
		reponse.toLowerCase();
		if (reponse.compareToIgnoreCase("y")==0 || reponse.compareToIgnoreCase("o")==0||reponse.compareToIgnoreCase("oui")==0||reponse.compareToIgnoreCase("yes")==0)
			return true;
		return false;
		
	}
	
	
	
	/* Menu general */
	public static void menu(){
		
		int saisie=-1;
		
		while(saisie!=0){
			System.out.println("\n");
			System.out.println("Parc : "+parc.getNomParc());
			System.out.println();
			System.out.println(" *************** Menu General  ****************");
			System.out.println("1 - Ajout/Suppression d'Equipement");
			System.out.println("2 - Modifier l'etat d'un Composant ou d'un equipement");
			System.out.println("3 - Consultation des listes");
			System.out.println("4 - Gestion des connexions/impressions");
			System.out.println("5 - Checking");
			System.out.println("6 - Maintenance");
			System.out.println("7 - Gestion des Fournisseurs");
			System.out.println("8 - Gestion de l'application");
			System.out.println("0 - Quitter l'application");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				menu();
			}
			switch (saisie) {
			case 1 : 
				ajoutSupEquipement();
				break;
			case 2 : changeEtat();
			break;
			case 3 : consult();
			break;
			case 4 : gestionConnexion();
			break;
			case 5 : checking();
			break;
			case 6 : maintenance();
			break;
			case 7 : gestionFournisseurs();
			break;
			case 8 : gestion();
			break;
			case 0 : {System.out.println("Vous avez quitte l'application");
			System.exit(0);}
			break;
			}
		}
	}
	
	
	public static void ajoutSupEquipement()
	{
		
		int saisie=-1;
		String nom,nomComposant;
		Equipement e;
		boolean b;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Equipement  ****************");
			System.out.println("1 - Ajouter un Ordinateur");
			System.out.println("2 - Ajouter une imprimante");
			System.out.println("3 - Supprimer un equipement [Ordinateur ou Imprimante]");
			System.out.println("4 - Supprimer un Composant d'un l'ordinateur");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutSupEquipement();
			}
			switch (saisie) {
			case 1 : 
				ajoutOrdinateur();
				break;
			case 2 : 
				ajoutImprimante();
				break;
			case 3:
				
				System.out.println("Entrer le nom de l'equipement dans le parc:");
				nom=in.next();
				System.out.println("Attention la suppression d'un ordinateur entraine la suppression de tous ses composants");
				b=questionOuiNon("Voulez-vous continuer ?");
				if(b){
					parc.delEquipement(nom);
					System.out.println("Equipement "+nom +" supprime");
				}
				break;
			case 4 :
				System.out.println("Entrer le nom de l'ordinateur dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Ordinateur){
					System.out.println("Entrer le nom du composant a supprimer:");
					nomComposant=in.next();
					b=questionOuiNon("Voulez-vous continuer ?");
					if(b){
						((Ordinateur)(e)).delComposant(nomComposant);
						System.out.println("Composant "+nom + " retire");
					}
				}
				else
					System.out.println("L'equipement selectionne n'est pas un ordinateur");
				break;
			case 0 : 
				menu();
				break;
			}
		}
	}
	
	public static Composants ajoutComposant(){
		int saisie=-1;
		Scanner in = new Scanner(System.in);
		Composants c=null;
		String nom,marque,type;
		boolean b1,b2,b3;
		int i1,i2;
		float f1;
		System.out.println("\n");
		System.out.println(" *************** Menu Ajout Composant ****************");
		System.out.println("1 - Ajouter une UC");
		System.out.println("2 - Ajouter un Ecran");
		System.out.println("3 - Ajouter un Clavier");
		System.out.println("4 - Ajouter une Souris");
		System.out.println("5 - Ajouter un Disque Dur");
		System.out.println("6 - Ajouter un Lecteur cd/dvd");
		System.out.println("7 - Ajouter un graveur cd/dvd");
		System.out.println("8 - Ajouter une Carte Video");
		System.out.println("9 - Ajouter une Carte Son");
		System.out.println("10 - Ajouter une Carte Reseau");
		System.out.println("0 - Retour au menu precedent");
		System.out.println("Votre choix :");
		try{
			saisie=in.nextInt();
		}
		catch(InputMismatchException exp1){
			System.err.println("Erreur de Saisie");
			ajoutComposant();
		}
		
		
		System.out.println("Entrer le nom du Composant dans le parc:");
		nom=in.next();
		System.out.println("Entrer la Marque du Composant :");
		marque=in.next();
		System.out.println("Entrer le type du Composant :");
		type=in.next();
		
		
		switch (saisie) {
		case 1 : 
			//Ajout UC
			System.out.println("Entrer la Frequence du processeur en GHz");
			try{
				f1=in.nextFloat();
				c=new UC(nom,marque,type,f1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie : Attention a la virgule");
				ajoutComposant();
			}
			
			break;
		case 2 : 
			//Ajout Ecran  
			System.out.println("Entrer la Taille de l'ecran en pouces");
			try{
				f1=in.nextFloat();
				b1=questionOuiNon("L'ecran est-il plat?");
				c=new Ecran(nom,marque,type,f1,b1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie : Attention a la virgule");
				ajoutComposant();
			}
			break;
		case 3 : 
			//Ajout Clavier
			try{
				System.out.println("Entrer le Nombre de touches");
				i1=in.nextInt();
				b1=questionOuiNon("Le clavier est sans fil?");
				c=new Clavier(nom,marque,type,i1,b1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutComposant();
			}
			break;
		case 4 : 
			//Ajout Souris
			b1=questionOuiNon("La souris est sans fil?");
			b2=questionOuiNon("La souris possede une molette?");
			c=new Souris(nom,marque,type,b1,b2);
			break;
		case 5 : 
			//Ajout Disque Dur
			try{
				System.out.println("Entrer la vitesse de Lecture");
				i1=in.nextInt();
				b1=questionOuiNon("La lecteur est-il externe?");
				System.out.println("Entrer la Capacite du disque en Go");
				
				f1=in.nextFloat();
				c=new DisqueDur(nom,marque,type,i1,b1,f1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie : Attention a la virgule");
				ajoutComposant();
			}
			break;
		case 6 : 
			//Ajout Lecteur CD/DVD
			try{
				System.out.println("Entrer la vitesse de Lecture");
				i1=in.nextInt();
				b1=questionOuiNon("La lecteur est-il externe?");
				b2=questionOuiNon("La lecteur lit-il DVD?");
				c=new Lecteur(nom,marque,type,i1,b1,b2);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie ");
				ajoutComposant();
			}
			break;
		case 7 : 
			//Ajout Graveur CD/DVD
			try{
				System.out.println("Entrer la vitesse de Lecture");
				i1=in.nextInt();
				System.out.println("Entrer la vitesse d'ecriture");
				i2=in.nextInt();
				b1=questionOuiNon("La graveur est-il externe?");
				b2=questionOuiNon("La graveur est-il DVD?");
				b3=questionOuiNon("La graveur est-il DVD double couche?");
				c=new Graveur(nom,marque,type,i1,b1,i2,b2,b3);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie ");
				ajoutComposant();
			}
			break;
		case 8 : 
			//Ajout Carte Video
			try{
				System.out.println("Entrer la taille Memoire en Mo de la carte");
				i1=in.nextInt();
				c=new CarteVideo(nom,marque,type,i1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutComposant();
			}
			break;
		case 9 : 
			//Ajout Carte Son
			b1=questionOuiNon("La carte est elle externe?");
			c=new CarteSon(nom,marque,type,b1);
			break;
		case 10 : 
			//Ajout Carte Reseau
			b1=questionOuiNon("La carte est elle externe?");
			c=new CarteReseau(nom,marque,type,b1);
			break;
		case 0 : ajoutSupEquipement();
		break;
		
		}
		return c;
	}
	
	
	
	public static void ajoutOrdinateur(){
		Ordinateur o;
		Composants c;
		boolean b1;
		String nom,marque,type;
		System.out.println("Entrer le nom de l'Ordinateur:");
		nom=in.next();
		System.out.println("Entrer la Marque de l'Ordinateur :");
		marque=in.next();
		System.out.println("Entrer le type d'Ordinateur :");
		type=in.next();
		b1=questionOuiNon("L'ordinateur est il un portable?");
		o=new Ordinateur(nom,marque,type,b1);
		
		int saisie=-1;
		
		while(saisie!=0){
			System.out.println(" *************** Menu Ajout Ordinateur ****************");
			System.out.println("1 - Ajouter un Composant");
			System.out.println("2 - Lister la configuration courante de l'ordinateur cree");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
				// On lit le \n
				System.out.flush();
				in.next();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutOrdinateur();
			}
			switch (saisie) {
			case 1 : 
				c=ajoutComposant();
				o.addComposant(c);
				System.out.println("Composant bien ajoute a l'ordinateur");
				break;
			case 2:
				System.out.println(o.listerConfiguration());
				break;
			case 0 : 
				parc.addEquipement(o);
				System.out.println("Ordinateur bien ajoute au Parc");
				ajoutSupEquipement();
				break;
			}
		}
	}
	
	public static void ajoutImprimante(){
		Imprimante i;

		boolean estUSB,estReseau;
		String nom,marque,type;
		System.out.println(" *************** Ajout d'un imprimante  ****************");
		System.out.println("Entrer le nom de l'imprimante dans le parc:");
		nom=in.next();
		System.out.println("Entrer la Marque de l'imprimante :");
		marque=in.next();
		System.out.println("Entrer le type d'imprimante :");
		type=in.next();
		estUSB=questionOuiNon("L'imprimante se branche en USB?");
		estReseau=questionOuiNon("L'imprimante se branche en reseau?");
		
		i=new Imprimante(nom,marque,type,estUSB,estReseau);
		parc.addEquipement(i);
		System.out.println("Imprimante bien ajoutee");
		ajoutSupEquipement();
	}
	
	
	
	
	
	
	public static void changeEtat()
	{

		
		int saisie=-1;
		String nom,nomComposant;
		Equipement e;
		Composants c;
		boolean b;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Etat  ****************");
			System.out.println("1 - Modifier l'etat d'une imprimante");
			System.out.println("2 - Modifier l'etat d'un composant d'un ordinateur");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
				
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				changeEtat();
			}
			switch (saisie) {
			case 1:
				
				System.out.println("Entrer le nom de l'imprimante dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Imprimante)
				{
					b=questionOuiNon("L'imprimante est defectueuse?");
					((Imprimante)e).setEtat(b);
					if(b)
						System.out.println("Etat de l'equipement "+nom +" modifie : Imprimante defectueuse");
					else
						System.out.println("Etat de l'equipement "+nom +" modifie : Imprimante en fonctionnement");
				}
				break;
			case 2 :
				System.out.println("Entrer le nom de l'ordinateur dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Ordinateur){
					System.out.println("Entrer le nom du composant a modifier:");
					nomComposant=in.next();
					
					c=((Ordinateur)(e)).getComposant(nomComposant);
					if (c!=null){
						b=questionOuiNon("Le composant "+nom+ " est defectueux ?");
						if (b)
							System.out.println("Composant "+nomComposant + " modifie : Etat defectueux");
						else
							System.out.println("Composant "+nomComposant + " modifie : Etat non defectueux");
					}
					else
						System.out.println("Composant "+nomComposant+" introuvable");
					
				}
				else
					System.out.println("L'equipement selectionne n'est pas un ordinateur");
				break;
			case 0 : 
				menu();
				break;
			}
		}
	}
	
	
	
	
	
	public static void consult(){
		
		int saisie=-1;
		String nom;
		Ordinateur o;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Consultation des listes  ****************");
			System.out.println("1 - Lister tous les equipements du parc");
			System.out.println("2 - Lister un equipement Particulier [Imprimante ou Ordinateur]");
			
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				consult();
			}
			switch (saisie) {
			case 1 : 
				parc.listerEquipement();
				break;
			case 2 : 
				System.out.println("Entrer le nom de l'equipement dans le parc:");
				nom=in.next();
				if(parc.getEquipement(nom) instanceof Imprimante){
					System.out.println(parc.getEquipement(nom));
				}
				else {
					if(parc.getEquipement(nom) instanceof Ordinateur){
						o=(Ordinateur)(parc.getEquipement(nom));
						System.out.println(o.listerConfiguration());
					}
					else{
						System.out.println("Equipement Introuvable");
					}
				}
				
				
				break;
			case 0 : menu();
			break;
			}
		}
		
	}
	
	public static void gestionConnexion()
	{
		
		int saisie=-1;
		String nom;
		Equipement e;
		int i;
		
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Gestion Connexion/Impression  ****************");
			System.out.println("1 - Incrementer le nombre de connexion d'un Ordinateur");
			System.out.println("2 - Incrementer le nombre d'impression d'une imprimante");
			System.out.println("3 - Consulter le nombre de connexions d'un ordinateur");
			System.out.println("4 - Consulter le nombre d'impressions d'une imprimante");
			System.out.println("5 - Calculer le nombre de connexion total du parc");
			System.out.println("6 - Calculer le nombre d'impression total du parc");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				gestionConnexion();
			}
			switch (saisie) {
			case 1:
				System.out.println("Entrer le nom de l'ordinateur dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Ordinateur){
					((Ordinateur)e).incrementerConnexion();
					System.out.println("Le total de connexions de cet ordinateur est "+((Ordinateur)e).getNbConnexions());
				}
				else
					System.out.println("L'equipement selectionne n'est pas un ordinateur");
				break;
			case 2:   
				System.out.println("Entrer le nom de l'imprimante dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Imprimante)
				{
					System.out.println("Entrer le nombre de pages imprimees");
					i=in.nextInt();
					((Imprimante)e).incrementerImpression(i);
					System.out.println("Le total d'impression de cette imprimante est "+((Imprimante)e).getNbPagesImprimees());
				}
				else
					System.out.println("L'equipement selectionne n'est pas une imprimante");
				break;
			case 3 :
				System.out.println("Entrer le nom de l'ordinateur dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Ordinateur){
					System.out.println("Le total de connexions de cet ordinateur est "+((Ordinateur)e).getNbConnexions());
				}
				else
					System.out.println("L'equipement selectionne n'est pas un ordinateur");
				break;
			case 4:   
				System.out.println("Entrer le nom de l'imprimante dans le parc:");
				nom=in.next();
				e=parc.getEquipement(nom);
				if (e instanceof Imprimante)
				{
					System.out.println("Le total d'impression de cette imprimante est "+((Imprimante)e).getNbPagesImprimees());
				}
				else
					System.out.println("L'equipement selectionne n'est pas une imprimante");
				break;
			case 5:
				System.out.println("Le nombre connexion total du parc est de :"+parc.getNbConnexionsParc());
				break;
			case 6:
				System.out.println("Le nombre d'impression total du parc est de :"+parc.getNbPagesImprimeesParc());
				break;
			case 0 : 
				menu();
				break;
			}
		}
	}
	
	
	/* Menu de checking */
	public static void checking(){
		
		int saisie=-1;
		
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" **** Menu Checking - Affichage des equipements defectueux ******");
			System.out.println("1 - Checker l'ensemble des Equipements du parc");
			System.out.println("2 - Checker un Equipement particulier");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				checking();
			}
			switch (saisie) {
			case 1 : 
				parc.listerDefectueux();
				break;
			case 2 : 
				String code;
				System.out.println("Entrer le nom de l'equipement a checker : ");
				code=in.next();
				parc.listerDefectueux(code);
				break;
			case 0 : menu();
			break;
			}
		}
	}
	
	
	
	
	
	
	
	
	
	public static ComposantsCat ajoutComposantCat(Catalogue cat){
		int saisie=-1;
		Scanner in = new Scanner(System.in);
		ComposantsCat c=null;
		String reference,marque,type;
		
		boolean venduDetail,b1,b2,b3;
		int i1,i2;
		float prix=0,f1;
		System.out.println("\n");
		System.out.println(" *************** Menu Ajout Composant au catalogue ****************");
		System.out.println(" ** Catalogue >> "+cat.getNom());
		
		System.out.println("1 - Ajouter une UC");
		System.out.println("2 - Ajouter un Ecran");
		System.out.println("3 - Ajouter un Clavier");
		System.out.println("4 - Ajouter une Souris");
		System.out.println("5 - Ajouter un Disque Dur");
		System.out.println("6 - Ajouter un Lecteur cd/dvd");
		System.out.println("7 - Ajouter un graveur cd/dvd");
		System.out.println("8 - Ajouter une Carte Video");
		System.out.println("9 - Ajouter une Carte Son");
		System.out.println("10 - Ajouter une Carte Reseau");
		System.out.println("0 - Retour au menu precedent");
		System.out.println("Votre choix :");
		try{
			saisie=in.nextInt();
		}
		catch(InputMismatchException exp1){
			System.err.println("Erreur de Saisie");
			ajoutComposantCat(cat);
		}
		if (saisie==0){
			ajouterProduit(cat);
		}
		
		System.out.println("Entrer la reference du Produit Composant :");
		reference=in.next();
		try{
			System.out.println("Entrer le prix du Composant :");
			prix=in.nextFloat();
		}
		catch(InputMismatchException exp1){
			System.err.println("Erreur de Saisie : Attention a la virgule pour le prix");
			ajoutComposantCat(cat);
		}
		venduDetail=questionOuiNon("Le composant est-il vendu au detail");
		System.out.println("Entrer la Marque du Composant :");
		marque=in.next();
		System.out.println("Entrer le type du Composant :");
		type=in.next();
		
		
		switch (saisie) {
		case 1 : 
			//Ajout UC
			try{
				System.out.println("Entrer la Frequence du processeur en GHz");
				f1=in.nextFloat();
				c=new UcCat(marque,prix,reference,type,venduDetail,f1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie : Attention a la virgule");
				ajoutComposantCat(cat);
			}
			break;
		case 2 : 
			//Ajout Ecran  
			try{
				System.out.println("Entrer la Taille de l'ecran en pouces");
				f1=in.nextFloat();
				b1=questionOuiNon("L'ecran est-il plat?");
				c=new EcranCat(marque,prix,reference,type,venduDetail,f1,b1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie : Attention a la virgule");
				ajoutComposantCat(cat);
			}
			break;
		case 3 : 
			//Ajout Clavier
			try{   
				System.out.println("Entrer le Nombre de touches");
				i1=in.nextInt();
				b1=questionOuiNon("Le clavier est sans fil?");
				c=new ClavierCat(marque,prix,reference,type,venduDetail,i1,b1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutComposantCat(cat);
			}
			break;
		case 4 : 
			//Ajout Souris
			b1=questionOuiNon("La souris est sans fil?");
			b2=questionOuiNon("La souris possede une molette?");
			c=new SourisCat(marque,prix,reference,type,venduDetail,b1,b2);
			break;
		case 5 : 
			//Ajout Disque Dur
			try{
				System.out.println("Entrer la vitesse de Lecture");
				i1=in.nextInt();
				b1=questionOuiNon("La lecteur est-il externe?");
				System.out.println("Entrer la Capacite du disque en Go");
				f1=in.nextFloat();
				c=new DisqueDurCat(marque,prix,reference,type,venduDetail,i1,b1,f1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie : Attention a la virgule");
				ajoutComposantCat(cat);
			}
			
			break;
		case 6 : 
			//Ajout Lecteur CD/DVD
			try {
				System.out.println("Entrer la vitesse de Lecture");
				i1=in.nextInt();
				b1=questionOuiNon("La lecteur est-il externe?");
				b2=questionOuiNon("La lecteur lit-il DVD?");
				c=new LecteurCat(marque,prix,reference,type,venduDetail,i1,b1,b2);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutComposantCat(cat);
			}
			break;
		case 7 : 
			//Ajout Graveur CD/DVD
			try{
				System.out.println("Entrer la vitesse de Lecture");
				i1=in.nextInt();
				System.out.println("Entrer la vitesse d'ecriture");
				i2=in.nextInt();
				b1=questionOuiNon("La graveur est-il externe?");
				b2=questionOuiNon("La graveur est-il DVD?");
				b3=questionOuiNon("La graveur est-il DVD double couche?");
				c=new GraveurCat(marque,prix,reference,type,venduDetail,i1,b1,i2,b2,b3);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutComposantCat(cat);
			}
			break;
		case 8 : 
			//Ajout Carte Video
			try{
				System.out.println("Entrer la taille Memoire en Mo de la carte");
				i1=in.nextInt();
				c=new CarteVideoCat(marque,prix,reference,type,venduDetail,i1);
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajoutComposantCat(cat);
			}
			break;
		case 9 : 
			//Ajout Carte Son
			b1=questionOuiNon("La carte est elle externe?");
			c=new CarteSonCat(marque,prix,reference,type,venduDetail,b1);
			break;
		case 10 : 
			//Ajout Carte Reseau
			b1=questionOuiNon("La carte est elle externe?");
			c=new CarteReseauCat(marque,prix,reference,type,venduDetail,b1);
			break;
		
		
		}
		return c;
	}
	
	
	
	
	
	
	public static void ajouterProduit(Catalogue cat)
	{
		
		int saisie=-1;
		String reference,referenceCompo,marque,type;
		float prix;
		ComposantsCat composant;
		OrdinateurCat o=null;
		Produits p;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Ajout Produit  ****************");
			System.out.println(" >>> Catalogue "+cat.getNom());
			
			System.out.println("1 - Ajouter un Composant au catalogue");
			System.out.println("2 - Ajouter un Composant a un Ordinateur (deja cree ou non dans le catalogue)");
			System.out.println("3 - Ajouter une imprimante au catalogue");
			System.out.println("4 - Supprimer un produit [imprimante/Ordinateur ou composant seul]");
			System.out.println("5 - Supprimer un composant d'un ordinateur");
			System.out.println("6 - Lister les caracteristiques d'un produit");
			
			System.out.println("7 - Modifier le prix d'un produit");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				ajouterProduit(cat);
			}
			switch (saisie) {
			case 1 : 
				composant=ajoutComposantCat(cat);
				cat.addProduit(composant);
				System.out.println("Composant ajoute au catalogue");
				break;
			case 2:
				
				
				
				System.out.println(" *************** Ajout/modification d'un ordinateur au catalogue ****************");
				
				System.out.println("Entrer la Reference de l'ordinateur dans le catalogue :");
				reference=in.next();
				p=cat.getProduit(reference);
				if (!(p instanceof OrdinateurCat))
				{
					boolean estPortable,b;
					System.out.println("Ordinateur "+reference+" inexistant !");
					b=questionOuiNon("Voulez-vous le creer ?");
					if(b)
					{
						System.out.println("Entrer la Marque de l'ordinateur :");
						marque=in.next();	
						System.out.println("Entrer le type d'ordinateur :");
						type=in.next();
						estPortable=questionOuiNon("L'ordinateur est-il un portable?");	
						o=new OrdinateurCat(marque,0,reference,type,estPortable);
						cat.addProduit(o);
						
						System.out.println("Ordinateur bien ajoute au catalogue "+cat.getNom());
					}
					else
					{
						ajouterProduit(cat);
					}
				}
				else {
					o=(OrdinateurCat)p;
				}
				System.out.println("Entrer la Reference du composant a ajouter Reference Catalogue:");
				referenceCompo=in.next();
				
				composant=(ComposantsCat)cat.getProduit(referenceCompo);
				if (o!=null && composant!=null)
				{
					o.addComposant(composant);
					// On recalcule le prix de l'ordinateur a chaque ajout d'un composant
					o.setPrix(o.calculPrixOrdinateur());
				}
				else
				{
					System.out.println("Composant introuvable");
					ajouterProduit(cat);
				}
				
				
				
				
				break;
			case 3 : 
				ImprimantesCat i;
				
				
				boolean estUSB,estReseau;
				System.out.println(" *************** Ajout d'un imprimante au catalogue ****************");
				System.out.println("Entrer la Reference de l'imprimante dans le catalogue:");
				reference=in.next();
				try{
					System.out.println("Entrer le prix de l'imprimante:");
					prix=in.nextFloat();
					
					System.out.println("Entrer la Marque de l'imprimante :");
					marque=in.next();
					System.out.println("Entrer le type d'imprimante :");
					type=in.next();
					
					estUSB=questionOuiNon("L'imprimante se branche en USB?");
					estReseau=questionOuiNon("L'imprimante se branche en reseau?");
					
					i=new ImprimantesCat(marque,prix,reference,type,estUSB,estReseau);
					cat.addProduit(i);
					System.out.println("Imprimante bien ajoutee au catalogue "+cat.getNom());
				}
				catch(InputMismatchException exp1){
					System.err.println("Erreur de Saisie");
					ajouterProduit(cat);
				}
				break;
				
			case 4 :
				System.out.println("Entrer la Reference du produit a supprimer dans le catalogue:");
				reference=in.next();
				
				p=cat.getProduit(reference);
				if(p==null)
				{
					System.out.println("Produit introuvable");
				}
				else
				{
					cat.delProduit(p);
				}
				break;
			case 5 :
				
				
				
				
				
				break;
			case 6:
				System.out.println("Entrer la Reference du produit a consulter dans le catalogue :");
				reference=in.next();
				
				p=cat.getProduit(reference);
				if(p==null)
				{
					System.out.println("Produit introuvable");
				}
				else
				{
					if ((p instanceof OrdinateurCat)){
						System.out.println("Configuration de l'ordinateur  :"+ reference);
						((OrdinateurCat)p).listerConfiguration();
					}
					else {
						System.out.println(p.toString());
					}
				}
				
				
				break;
			case 7 :
				float nouveauxPrix;
				System.out.println("Entrer la Reference du produit a modifier dans le catalogue :");
				reference=in.next();
				
				p=cat.getProduit(reference);
				if(p==null)
				{
					System.out.println("Produit introuvable");
				}
				else
				{
					if (!(p instanceof OrdinateurCat)){
						try{
							System.out.println("Entrer le nouveau prix du produit :");
							nouveauxPrix=in.nextFloat();
							p.setPrix(nouveauxPrix);
						}
						catch(InputMismatchException exp1){
							System.err.println("Erreur de Saisie dans le prix");
							ajouterProduit(cat);
						}
					}
					else{
						System.err.println("Un Ordinateur calcule son prix automatiquement a l'ajout de composants");
					}
				}
			case 0 : 
				gestionFournisseurs();
				break;
				
				
			}
		}
	}
	
	
	
	
	
	
	
	public static void gestionFournisseurs(){
		
		int saisie=-1;
		String nom,nomCatalogue;
		Fournisseur f;
		Catalogue c;
		Produits p;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Fournisseur  ****************");
			System.out.println("1 - Creer un Fournisseur");
			System.out.println("2 - Supprimer un Fournisseur");
			System.out.println("3 - Liste des Fournisseurs avec leurs catalogues");
			System.out.println("4 - Creer un Catalogue au fournisseur");
			System.out.println("5 - Supprimer un Catalogue");
			System.out.println("6 - Ajouter/Modifier/supprimer/Consulter un Produit d'un Catalogue");
			System.out.println("7 - Liste des Produits d'un Catalogue");
			
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				gestionFournisseurs();
			}
			switch (saisie) {
			case 1 : 
				
				System.out.println("Entrer le nom du Fournisseur a ajouter");
				nom=in.next();
				if (nom!=""){
					f=new Fournisseur(nom);
					parc.addFournisseur(f);
				}
				else
				{
					System.err.println("Erreur de Saisie");
					gestionFournisseurs();
				}
				break;
			case 2 : 
				System.out.println("Entrer le nom du Fournisseur a Supprimer");
				nom=in.next();
				f=parc.getFournisseur(nom);
				if(f!=null)
					parc.delFournisseur(f);
				else
					System.err.println("Impossible de supprimer ce Fournisseur - Fournisseur Inexistant");
				break;
				
			case 3:
				
				for (String code:parc.getListeFournisseur().keySet()){
					f=parc.getListeFournisseur().get(code);
					System.out.println("Fournisseur : "+f.getNom());
					System.out.println("\tListe des catalogues : ");
					for (String nomCat : f.getListeCatalogues().keySet()){
						System.out.println("\t\t"+f.getListeCatalogues().get(nomCat).getNom());
					}
				}
				
				
				break;
				
			case 4 : 
				System.out.println("Entrer le nom du Fournisseur :");
				nom=in.next();
				f=parc.getFournisseur(nom);
				if (f!=null)
				{
					System.out.println("Entrer le nom du Catalogue a ajouter :");
					
					nomCatalogue=in.next();
					if (nomCatalogue!=""){
						c=new Catalogue(nomCatalogue);
						f.addCatalogue(c);
					}
					else
					{
						System.err.println("Veuiller saisir le nom du catalogue");
					}
				}
				else
				{
					System.err.println("Impossible d'ajouter ce Catalogue - Fournisseur Inexistant");
				}
				break;
				
				
				
			case 5 : 
				System.out.println("Entrer le nom du Fournisseur : ");
				nom=in.next();
				f=parc.getFournisseur(nom);
				if (f!=null)
				{
					System.out.println("Entrer le nom du Catalogue a supprimer :");
					nomCatalogue=in.next();
					c=f.getCatalogue(nomCatalogue);
					if (c!=null){
						try{
							f.delCatalogue(c);
						}
						catch(ClassCastException e){};
					}
					else
						System.out.println("Impossible de supprimer ce catalogue - Catalogue Inexistant");
				}
				else
				{
					System.err.println("Impossible de supprimer ce Catalogue - Fournisseur Inexistant");
				}
				break;
				
				
				
				
			case 6 : 
				System.out.println("Entrer le nom du Fournisseur");
				nom=in.next();
				f=parc.getFournisseur(nom);
				if (f!=null)
				{
					System.out.println("Entrer le nom du Catalogue");
					nomCatalogue=in.next();
					c=f.getCatalogue(nomCatalogue);
					if (c!=null)
						ajouterProduit(c);
					else
						System.out.println("Impossible d'ajouter ce Produit - Catalogue Inexistant");
				}
				else
				{
					System.err.println("Impossible d'ajouter ce Produit - Fournisseur Inexistant");
				}
				break;
				
			case 7 : 
				System.out.println("Entrer le nom du Fournisseur");
				nom=in.next();
				f=parc.getFournisseur(nom);
				if (f!=null)
				{
					System.out.println("Entrer le nom du Catalogue");
					nomCatalogue=in.next();
					c=f.getCatalogue(nomCatalogue);
					if (c!=null)
						for(String Produit:c.getListeProduit().keySet())
						{
							p=c.getListeProduit().get(Produit);
							
							if(p instanceof ComposantsCat){
								if (((ComposantsCat)p).isVenduAuDetail()){
									System.out.println(p.getClass().getSimpleName()+"\t"+p.getMarque()+"\t"+p.getReference()+"\t"+p.getPrix());
								}
							}
							else{
								System.out.println(p.getClass().getSimpleName()+"\t"+p.getMarque()+"\t"+p.getReference()+"\t"+p.getPrix());
							}
						}
					
					else
						System.out.println("Catalogue Inexistant");
				}
				else
				{
					System.err.println("Fournisseur Inexistant");
				}
				break; 	
				
			case 0 : menu();
			break;
			}
		}
	}
	
	
	public static String devisOrdinateur(String nomOrdinateur)
	{
		Equipement e1;
		Ordinateur o;
		Composants c;
		String texte;
		boolean composantNonTrouve=false;
		TreeMap<String,Composants> listeDefectueux=null;
		float prixOrdiComplet,prixPiece,prixTotalPieces=0;
		e1=parc.getEquipement(nomOrdinateur);
		if(e1 instanceof Ordinateur)
		{
			
			o=(Ordinateur)e1;
			texte="Devis de Maintenance pour l'ordinateur  : "+nomOrdinateur+"\n"+((Ordinateur)e1).toString();
			
			texte+="\n\nDevis Remplacement Pieces defectueuses uniquement :";
			if(o!=null){
				listeDefectueux=o.getListeDefectueux();
				if(listeDefectueux!=null){
					for(String code:listeDefectueux.keySet())
					{
						c=listeDefectueux.get(code);
						prixPiece=parc.getMeilleurPrixFournisseurs(c);
						if (prixPiece!=-1){
							prixTotalPieces+=prixPiece;
							texte+="\n"+"Piece : "+code+"\ttrouve au prix de "+prixPiece +" Euros";
						}
						else{
							texte+="\nPiece : "+code+"\tnon trouvee";
							composantNonTrouve=true;
						}
					}
					
					texte+="\n----------------------------------------------------------------------";
					texte+="\nCout total au detail : "+prixTotalPieces +" Euros";
					
					
				}
				else
					System.out.println("Erreur");
			}
			
			if (prixTotalPieces==0)
			{
				texte+="\n Aucune Pieces a changer";
			}
			
			texte+="\n\n\n";
			prixOrdiComplet=parc.getMeilleurPrixFournisseurs(o);
			if(prixOrdiComplet !=-1)
				texte+="\nPrix d'un ordinateur complet : "+prixOrdiComplet;
			else
				texte+="\n Impossible de trouver un ordinateur correpondant aux caracteristiques de l'ordinateur";
			
			
			if(!composantNonTrouve && prixTotalPieces>0 && prixOrdiComplet>0 && prixOrdiComplet<prixTotalPieces)
			{
				texte+="\n\n On choisit d'acheter l'ordinateur Complet";
			}
			else
			{
				if(!composantNonTrouve && prixTotalPieces>0)
					texte+="\n\n On choisira de remplacer l'ordinateur au detail";
				else
				{
					texte+="\n \nImpossible de resoudre le calcul du meilleur prix";
				}
			}
			
		}
		else
			texte="Ceci n'est pas un ordinateur";
		
		return texte;
		
	}
	
	
	
	/* Menu de maintenance  */
	public static void maintenance(){
		
		int saisie=-1;
		String materiel,ordi;
		Equipement e;
		Ordinateur o;
		Composants c;
		float prix=0;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Maintenance du Parc  ****************");
			System.out.println("1 - Meilleur prix d'un equipement particulier");
			System.out.println("2 - Meilleur prix d'un composant particulier");
			System.out.println("3 - Meilleur cout de remplacement de tous les equipements defectueux");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				maintenance();
			}
			switch (saisie) {
			case 1 : 
				System.out.println("Entrer le nom de l'equipement :");
				materiel=in.next();
				e=parc.getEquipement(materiel);
				if(e!=null){
					if (e instanceof Imprimante){
						prix=parc.getMeilleurPrixFournisseurs(e);
						if(prix!=-1)
						{
							System.out.println("Le meilleur prix donne est de : "+prix +" Euros");
						}
						else
						{
							System.out.println("Ce type d'equipement est trop recent par rapport aux catalogues");
						}
					}
					else{
						if(e instanceof Ordinateur){
							System.out.println(devisOrdinateur(e.getNom()));
						}
					}
				}
				else
				{
					System.out.println("Equipement introuvable");
				}
				
				break;
			case 2 : 
				System.out.println("Entrer le nom de l'ordinateur ou se trouve composant a evaluer :");
				ordi=in.next();
				
				System.out.println("Entrer le nom du composant a evaluer :");
				materiel=in.next();
				
				
				o=(Ordinateur)(parc.getEquipement(ordi));
				try{
					c=o.getComposant(materiel);
					if(c!=null){
						prix=parc.getMeilleurPrixFournisseurs(c);
						if(prix!=-1)
						{
							System.out.println("Le meilleur prix donne est de : "+prix+ " Euros");
						}
						else
						{
							System.out.println("Ce type d'equipement est trop recent par rapport aux catalogues");
						}
					}
				}
				catch(NullPointerException exp)
				{	
					System.out.println("Composant introuvable");
				}
				break;
				
			case 3 : 
				TreeMap<String,Equipement> listeEquipement;
				listeEquipement=parc.getListeEquipement();
				
				
				e=null;
				for(String code:listeEquipement.keySet())
				{
					e=listeEquipement.get(code);
					if(e instanceof Ordinateur){
						if(((Ordinateur)e).CalculerEtatOrdinateur())
							System.out.println(devisOrdinateur( ((Ordinateur)e).getNom())+"\n");
					}
					
					if(e instanceof Imprimante){
						if(((Imprimante)e).isEtat()){
							prix=0;
							prix=parc.getMeilleurPrixFournisseurs(e);
							if(prix!=-1)
							{
								System.out.println("Imprimante : "+((Imprimante)e).toString()+" \t Prix :"+prix +" Euros\n\n");
							}
							else
							{
								System.err.println("Imprimante : "+((Imprimante)e).toString()+" \t Impossible de trouver le prix\n\n");
							}
							
						}
					}
					
				}
				break;
				
				
			case 0 : menu();break;
			}
		}
	}
	
	
	
	
	
	/* Menu de gestion de l'application */
	public static void gestion(){
		
		int saisie=-1;
		while(saisie!=0){
			System.out.println("\n");
			System.out.println(" *************** Menu Gestion de l'application  ****************");
			System.out.println("1 - Sauver un parc");
			System.out.println("2 - Charger un parc");
			System.out.println("0 - Retour au menu precedent");
			System.out.println("Votre choix :");
			try{
				saisie=in.nextInt();
			}
			catch(InputMismatchException exp1){
				System.err.println("Erreur de Saisie");
				gestion();
			}
			switch (saisie) {
			case 1 : 
				try {
					save();
				} catch (IOException e) {
					System.out.println("Impossible de sauvegarder le Parc");
					e.printStackTrace();
				}
				
				break;
			case 2 : 
				try {
					load();
				} catch (IOException e) {
					System.out.println("Impossible de charger le Parc");
					System.out.println("Fichier non valide");
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					System.out.println("Impossible de charger le Parc");
					System.out.println("Classe non trouvee");
					e.printStackTrace();
				}
				break;
			case 0 : menu();break;
			}
		}
	}
	
	
	
	
	/* Sauvegarde de l'etat du parc : Parc implementant la serialisation */
	/* On peut directement utiliser la methode writeObject dessus */
	
	public static void save() throws IOException{
		ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("sauvegarde.ser")); 
		out.writeObject(parc);
		out.close();
		System.out.println("Le parc a bien ete sauvegarde. Vous pouvez quitter l'application");
	}
	
	/* Chargement du parc */
	public static void load() throws IOException,ClassNotFoundException{
		try{
			ObjectInputStream in = new ObjectInputStream(new FileInputStream("sauvegarde.ser")); 
			parc=(Parc)in.readObject();
			System.out.println("Parc charge");
		}
		catch(FileNotFoundException ex){
			System.out.println("Fichier inexistant");
		}
	}
	
	
	
	public static void main(String []args){
		menu();
	}
	
}
