/** CarteSonCat.java */
package fournisseurs;
import parcInfo.*;
@SuppressWarnings("serial")
public class CarteSonCat extends ComposantsCat
{
	private boolean estExterne;
	
	
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param estExterne
	 */
	public CarteSonCat(String marque, float prix, String reference, String type, boolean venduAuDetail, boolean estExterne) {
		super(marque, prix, reference, type, venduAuDetail);
		this.estExterne = estExterne;
	}
	
	
	
	
	/**
	 * @return vrai si la Carte son est Externe
	 */
	public boolean isEstExterne() {
		return estExterne;
	}
	
	
	/**
	 * @param estExterne initialisation de la variable
	 */
	public void setEstExterne(boolean estExterne) {
		this.estExterne = estExterne;
	}
	
	
	
	
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
	{
		String chaine="Carte son ";
		
		if(estExterne)
			chaine+=" externe";
		else
			chaine+=" interne";
		return chaine +"\n"+ super.toString();
	}
	
	/**
	 * On compare ici si une carteSon est egale a celle passee en parametre
	 * On considere qu'une carte Son est egale a une autre si elle est  
	 * externe
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
	public boolean egalOuSuperieur(Composants c, boolean VenteAuDetail)
	{
		if (c instanceof CarteSon && VenteAuDetail==super.isVenduAuDetail() && this.isEstExterne()==((CarteSon)c).isEstExterne())
			return true;
		return false;
	}
	
	/**
	 * @param e Equipement : l'equipement a tester
	 * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
	 */
	public boolean egalOuSuperieur(Equipement e)
	{
		return false;
	}
	
}
