/** CarteVideoCat.java */
package fournisseurs;
import parcInfo.*;
@SuppressWarnings("serial")
public class CarteVideoCat extends ComposantsCat
{
    private int tailleMemoire;

	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param tailleMemoire
	 */
	public CarteVideoCat(String marque, float prix, String reference, String type, boolean venduAuDetail, int tailleMemoire) {
		super(marque, prix, reference, type, venduAuDetail);
		this.tailleMemoire = tailleMemoire;
	}


	/**
	 * @return la taille Memoire de la carte video
	 */
	public int getTailleMemoire() {
		return tailleMemoire;
	}


	/**
	 * @param tailleMemoire : initialisation de la variable tailleMemoire
	 */
	public void setTailleMemoire(int tailleMemoire) {
		this.tailleMemoire = tailleMemoire;
	}

	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
    {
		String chaine="Carte video ";
	
		return chaine +"\n"+ super.toString()+" taille memoire : "+tailleMemoire+"\n";
    }

	/**
	 * On compare ici si une carteVideo est superieure ou egale a celle passee en parametre
	 * On considere qu'une carte video est superieure ou egale a une autre si sa taille  
	 * memoire est egale ou plus grande
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
    public boolean egalOuSuperieur(Composants c, boolean VenteAuDetail)
    {
	if (c instanceof CarteVideo && VenteAuDetail==this.isVenduAuDetail() && this.getTailleMemoire()>=((CarteVideo)c).getTailleMemoire())
	    return true;
	return false;
    }


    /**
     * @param e Equipement : l'equipement a tester
     * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
     * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
     */
    public boolean egalOuSuperieur(Equipement e)
    {
    	return false;
    }
}
