/** ClavierCat.java */
package fournisseurs;
import parcInfo.*;

@SuppressWarnings("serial")
public class ClavierCat extends ComposantsCat
{
    private int nombreDeTouches;
    private boolean estSansFil;
 
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param nombreDeTouches
	 * @param estSansFil
	 */
	public ClavierCat(String marque, float prix, String reference, String type, boolean venduAuDetail, int nombreDeTouches, boolean estSansFil) {
		super(marque, prix, reference, type, venduAuDetail);
		this.nombreDeTouches = nombreDeTouches;
		this.estSansFil = estSansFil;
	}

	/**
	 * @return si estSansFil
	 */
	public boolean isEstSansFil() {
		return estSansFil;
	}

	/**
	 * @param estSansFil specifie si le clavier est sans fil 
	 */
	public void setEstSansFil(boolean estSansFil) {
		this.estSansFil = estSansFil;
	}

	/**
	 * @return le nombreDeTouches
	 */
	public int getNombreDeTouches() {
		return nombreDeTouches;
	}

	/**
	 * @param nombreDeTouches le nombreDeTouches a mettre
	 */
    public void setNombreDeTouches(int nombreDeTouches) {
	this.nombreDeTouches = nombreDeTouches;
    }
    
    /**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
    {
		return "Clavier \n"+super.toString()+" nombre de touches : " + nombreDeTouches +"\n";    
	}
	
	/**
	 * On compare ici si un clavier est egal a celui passee en parametre
	 * On considere qu'un clavier est egal a un autre si il est  
	 * sans fil ou non
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
    public boolean egalOuSuperieur(Composants c, boolean VenteAuDetail)
    {
	if (c instanceof Clavier && VenteAuDetail==this.isVenduAuDetail() && this.isEstSansFil()==((Clavier)c).isEstSansFil())
	    return true;
	return false;
    }
    
    
    /**
     * @param e Equipement : l'equipement a tester
     * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
     * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
     */
    public boolean egalOuSuperieur(Equipement e)
    {
    	return false;
    }
}
