/** EcranCat.java */
package fournisseurs;
import parcInfo.*;

@SuppressWarnings("serial")
public class EcranCat extends ComposantsCat
{
    private float taille;
    private boolean estPlat;

	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param taille
	 * @param estPlat
	 */
	public EcranCat(String marque, float prix, String reference, String type, boolean venduAuDetail, float taille, boolean estPlat) {
		super(marque, prix, reference, type, venduAuDetail);
		this.taille = taille;
		this.estPlat = estPlat;
	}

	/**
	 * @return vrai si l'ecran estPlat
	 */
	public boolean isEstPlat() {
		return estPlat;
	}

	/**
	 * @param estPlat initialise la variable estPlat
	 */
	public void setEstPlat(boolean estPlat) {
		this.estPlat = estPlat;
	}

	/**
	 * @return la taille de l'ecran
	 */
	public float getTaille() {
		return taille;
	}

	/**
	 * @param taille initialisation de la taille
	 */
	public void setTaille(float taille) {
		this.taille = taille;
	}

    /**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
    {
	String chaine="Ecran ";

	if(estPlat)
	    chaine+=" plat ";
	return chaine +"\n"+super.toString()+ " taille : "+ this.taille+" pouces\n";
	
    }

	/**
	 * On compare ici si un Ecran est egal ou superieur a celui passe en parametre
	 * On considere qu'un Ecran est egal ou superieur a un autre si il   
	 * a une taille superieure ou egale et si il est plat ou non comme celui-ci
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
    public boolean egalOuSuperieur(Composants c,boolean VenteAuDetail)
    {
	if (c instanceof Ecran && VenteAuDetail==this.isVenduAuDetail() && this.getTaille()>=((Ecran)c).getTaille() && this.isEstPlat()==((Ecran)c).isEstPlat())
	    return true;
	return false;
    }

    /**
     * @param e Equipement : l'equipement a tester
     * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
     * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
     */
    public boolean egalOuSuperieur(Equipement e)
    {
    	return false;
    }
}
