/** GraveurCat.java */
package fournisseurs;
import parcInfo.*;
@SuppressWarnings("serial")
public class GraveurCat extends PeripheriqueCat
{
	private float vitesseEcriture;
	private boolean estDVD;
	private boolean estDVD9;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param vitesse
	 * @param estExterne
	 * @param vitesseEcriture
	 * @param estDVD
	 * @param estDVD9
	 */
	public GraveurCat(String marque, float prix, String reference, String type, boolean venduAuDetail, float vitesse, boolean estExterne, float vitesseEcriture, boolean estDVD, boolean estDVD9) {
		super(marque, prix, reference, type, venduAuDetail, vitesse, estExterne);
		this.vitesseEcriture = vitesseEcriture;
		this.estDVD = estDVD;
		this.estDVD9 = estDVD9;
	}
	
	/**
	 * @return vrai si le graveur grave les DVD
	 */
	public boolean isEstDVD() {
		return estDVD;
	}
	
	/**
	 * @param estDVD initialise la variable estDVD
	 */
	public void setEstDVD(boolean estDVD) {
		this.estDVD = estDVD;
	}
	
	/**
	 * @return vrai si le graveur grave les DVD double couche
	 */
	public boolean isEstDVD9() {
		return estDVD9;
	}
	
	/**
	 * @param estDVD9 initialise la variable estDVD9
	 */
	public void setEstDVD9(boolean estDVD9) {
		this.estDVD9 = estDVD9;
	}
	
	/**
	 * @return la vitesse d'Ecriture
	 */
	public float getVitesseEcriture() {
		return vitesseEcriture;
	}
	
	/**
	 * @param vitesseEcriture initialise la variable vitesseEcriture
	 */
	public void setVitesseEcriture(float vitesseEcriture) {
		this.vitesseEcriture = vitesseEcriture;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.PeripheriqueCat#toString()
	 */
	public String toString()
	{
		String chaine="Graveur ";
		
		if(estDVD)
			chaine=chaine + "DVD ";
		else {
			if(estDVD9)
				chaine=chaine + "DVD9 ";
		}
		return chaine +"\n"+super.toString()+"vitesse d'ecriture : "+vitesseEcriture+"X";	
	}
	
	/**
	 * On compare ici si un Graveur est egal ou superieur a celui passe en parametre
	 * On considere qu'un Graveur est egal ou superieur a un autre si il   
	 * a des vitesses superieures ou egales et si les caracteristiques sont les memes
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.PeripheriqueCat#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
	public boolean egalOuSuperieur(Composants c,boolean VenteAuDetail)
	{
		if (c instanceof Graveur && VenteAuDetail==this.isVenduAuDetail() && this.getVitesseEcriture()>=((Graveur)c).getVitesseEcriture() && this.isEstDVD()==((Graveur)c).isEstDVD() && this.isEstDVD9()==((Graveur)c).isEstDVD9() && this.isEstExterne()==((Graveur)c).isEstExterne() && this.getVitesse()>=((Graveur)c).getVitesse())
			return true;
		return false;
	}
	
	/**
	 * @param e Equipement : l'equipement a tester
	 * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
	 * @see fournisseurs.PeripheriqueCat#egalOuSuperieur(parcInfo.Equipement)
	 */
	public boolean egalOuSuperieur(Equipement e)
	{
		return false;
	}
}
