/** ImprimantesCat.java */
package fournisseurs;
import parcInfo.*;

@SuppressWarnings("serial")
public class ImprimantesCat extends Produits
{
	private boolean estUSB;
	private boolean estReseau;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param estUSB
	 * @param estReseau
	 */
	public ImprimantesCat(String marque, float prix, String reference, String type, boolean estUSB, boolean estReseau) {
		super(marque, prix, reference, type);
		this.estUSB = estUSB;
		this.estReseau = estReseau;
	}
	
	/**
	 * @return vrai si l'imprimante se connecte en Reseau
	 */
	public boolean isEstReseau() {
		return estReseau;
	}
	
	/**
	 * @param estReseau  initialise la variable estReseau 
	 */
	public void setEstReseau(boolean estReseau) {
		this.estReseau = estReseau;
	}
	
	/**
	 * @return vrai si l'imprimante se connecte en USB
	 */
	public boolean isEstUSB() {
		return estUSB;
	}
	
	/**
	 * @param estUSB  initialise la variable estUSB
	 */
	public void setEstUSB(boolean estUSB) {
		this.estUSB = estUSB;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.Produits#toString()
	 */
	public String toString()
	{
		String chaine="Imprimante";
		
		if(estReseau)
			chaine=chaine+" avec port Reseau";
		if(estUSB)
			chaine=chaine+" avec port USB";
		
		return chaine+"\n"+super.toString()+"\n";
	}
	
	
	
	/**
	 * On compare ici si une Imprimante est egale ou superieure a celle passee en parametre
	 * On considere qu'une Imprimante est egale ou superieure a une autre si elle   
	 * a les memes caracteristiques
	 * 
	 * @param e Equipement : l'equipement a tester
	 * @return boolean : boolean vrai Si le produit est superieur ou egal, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
     
	 */
	public boolean egalOuSuperieur(Equipement e)
	{
		if (e instanceof Imprimante && this.isEstUSB()==((Imprimante)e).isEstUSB() && this.isEstReseau()==((Imprimante)e).isEstReseau())
			return true;
		return false;
	}
	
	/**
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean Ici Toujours a faux car un equipement n'est pas un composant
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
	public boolean egalOuSuperieur(Composants c,boolean VenteAuDetail)
	{
		return false;
	}
}
