/** LecteurCat.java */
package fournisseurs;
import parcInfo.*;
@SuppressWarnings("serial")
public class LecteurCat extends PeripheriqueCat
{
	private boolean estDVD;
	
	
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param vitesse
	 * @param estExterne
	 * @param estDVD
	 */
	public LecteurCat(String marque, float prix, String reference, String type, boolean venduAuDetail, float vitesse, boolean estExterne, boolean estDVD) {
		super(marque, prix, reference, type, venduAuDetail, vitesse, estExterne);
		this.estDVD = estDVD;
	}
	
	/**
	 * @return vrai si le lecteur lit les DVD
	 */
	public boolean isEstDVD() {
		return estDVD;
	}
	
	/**
	 * @param estDVD  initialise la variable estDVD
	 */
	public void setEstDVD(boolean estDVD) {
		this.estDVD = estDVD;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.PeripheriqueCat#toString()
	 */
	public String toString()
	{
		String chaine=" Lecteur ";
		
		if(estDVD)
			chaine+=" DVD ";
		
		return chaine+"\n"+ super.toString()+"\n"; 
	}
	
	/**
	 * On compare ici si un Lecteur est egal ou superieur a celui passe en parametre
	 * On considere qu'un Lecteur est egal ou superieur a un autre si il   
	 * a une vitesse superieure ou egale et si les caracteristiques sont les memes
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.PeripheriqueCat#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
	public boolean egalOuSuperieur(Composants c, boolean VenteAuDetail)
	{
		if (c instanceof Lecteur && VenteAuDetail==this.isVenduAuDetail() && this.isEstDVD()==((Lecteur)c).isEstDVD() && this.isEstExterne()==((Lecteur)c).isEstExterne() && this.getVitesse()>=((Lecteur)c).getVitesse())
			return true;
		return false;
	}
	
	/**
	 * @param e Equipement : l'equipement a tester
	 * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
	 * @see fournisseurs.PeripheriqueCat#egalOuSuperieur(parcInfo.Equipement)
	 */
	public boolean egalOuSuperieur(Equipement e)
	{
		return false;
	}
}
