/** Classe Abstraite Produits.java */
package fournisseurs;
import parcInfo.*;
import java.io.*;

@SuppressWarnings("serial")
abstract public class Produits  implements Serializable
{
	private String marque;
	private float prix;
	private String reference;
	private String type;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 */
	public Produits(String marque, float prix, String reference, String type) {
		this.marque = marque;
		this.prix = prix;
		this.reference = reference;
		this.type = type;
	}
	
	/**
	 * @return la marque
	 */
	public String getMarque() {
		return marque;
	}
	
	/**
	 * @param marque  initialise la variable marque
	 */
	public void setMarque(String marque) {
		this.marque = marque;
	}
	
	/**
	 * @return le prix
	 */
	public float getPrix() {
		return prix;
	}
	
	/**
	 * @param prix  initialise la variable prix
	 */
	public void setPrix(float prix) {
		this.prix = prix;
	}
	
	/**
	 * @return la reference
	 */
	public String getReference() {
		return reference;
	}
	
	/**
	 * @param reference  initialise la variable reference
	 */
	public void setReference(String reference) {
		this.reference = reference;
	}
	
	/**
	 * @return le type
	 */
	public String getType() {
		return type;
	}
	
	/**
	 * @param type  initialise la variable type
	 */
	public void setType(String type) {
		this.type = type;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 */
	public String toString()
	{
		return " marque : "+this.marque+" prix : "+this.prix+" Reference : "+this.reference+" type : "+this.type ;
	}
	
	/**
	 * Methodes Abstraites pour comparer un equipement ou un composant a un du catalogue
	 */
	public abstract boolean egalOuSuperieur(Composants c, boolean VenteAuDetail);
	public abstract boolean egalOuSuperieur(Equipement c);
}
