/** SourisCat.java */
package fournisseurs;
import parcInfo.*;

@SuppressWarnings("serial")
public class SourisCat extends ComposantsCat
{
	private boolean estSansFil;
	private boolean avecMolette;
	
	/**
	 * @param marque
	 * @param prix
	 * @param reference
	 * @param type
	 * @param venduAuDetail
	 * @param estSansFil
	 * @param avecMolette
	 */
	public SourisCat(String marque, float prix, String reference, String type, boolean venduAuDetail, boolean estSansFil, boolean avecMolette) {
		super(marque, prix, reference, type, venduAuDetail);
		this.estSansFil = estSansFil;
		this.avecMolette = avecMolette;
	}
	
	/**
	 * @return vrai si la souris possede une Molette
	 */
	public boolean isAvecMolette() {
		return avecMolette;
	}
	
	/**
	 * @param avecMolette  initialise la variable avecMolette
	 */
	public void setAvecMolette(boolean avecMolette) {
		this.avecMolette = avecMolette;
	}
	
	/**
	 * @return vrai si la souris est Sans Fil
	 */
	public boolean isEstSansFil() {
		return estSansFil;
	}
	
	/**
	 * @param estSansFil  initialise la variable estSansFil
	 */
	public void setEstSansFil(boolean estSansFil) {
		this.estSansFil = estSansFil;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du produit
	 * @return String
	 * @see fournisseurs.ComposantsCat#toString()
	 */
	public String toString()
	{
		String chaine="Souris ";
		
		if(estSansFil)
			chaine+="sans fil ";
		else 
			chaine+="avec molette ";
		
		return chaine +"\n"+super.toString();
		
	}
	
	/**
	 * On compare ici si une souris est superieure ou egal a la souris passee en parametre
	 * On considere qu'une souris avec une molette ou sans fil est superieure a une souris  
	 * simple
	 * 
	 * @param c Composants : le composant a tester
	 * @param VenteAuDetail : vrai si le produit est vendu au detail faux sinon
	 * @return boolean vrai Si le produit est superieur, faux sinon
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Composants, boolean)
	 */
	public boolean egalOuSuperieur(Composants c, boolean VenteAuDetail)
	{
		if (c instanceof Souris && VenteAuDetail==this.isVenduAuDetail()){
			if ((((Souris)c).isEstSansFil()) && (!this.isEstSansFil())){
				return false;
			}
			else{
				if ((((Souris)c).isAvecMolette()) && (!this.isAvecMolette())  )
					return false;
				else
					return true;
			}
		}
		else
			return false;
	}
	
	/**
	 * @param e Equipement : l'equipement a tester
	 * @return boolean : Ici Toujours a faux car un composant n'est pas un equipement
	 * @see fournisseurs.Produits#egalOuSuperieur(parcInfo.Equipement)
	 */
	public boolean egalOuSuperieur(Equipement e)
	{
		return false;
	}
}
