package graphique;


import java.io.*;
import javax.swing.filechooser.FileFilter;

public class FiltreSimple extends FileFilter{
	
	//Description et extension acceptee par le filtre
	private String description;
	private String extension;
	
	//Constructeur a partir de la description et de l'extension acceptee
	public FiltreSimple(String description, String extension) throws NullPointerException{
		if(description == null || extension ==null){
			throw new NullPointerException();
		}
		this.description = description;
		this.extension = extension;
	}
	
	
	//Implementation de FileFilter
	public boolean accept(File file){
		if(file.isDirectory()) { 
			return true; 
		} 
		String nomFichier = file.getName().toLowerCase(); 
		return nomFichier.endsWith(extension);
	}
	public String getDescription(){
		return description;
	}
}
