/** CarteReseau.java */
package parcInfo;

@SuppressWarnings("serial")
public class CarteReseau extends Composants
{
	private boolean estExterne;
	
	/**
	 * @param nomComposant
	 * @param marqueComposant
	 * @param type
	 * @param estExterne
	 */
	public CarteReseau(String nomComposant, String marqueComposant, String type, boolean estExterne) {
		super(nomComposant, marqueComposant, type);
		this.estExterne = estExterne;
	}
	
	/**
	 * @return vrai si la carte reseau est Externe
	 */
	public boolean isEstExterne() {
		return estExterne;
	}
	
	/**
	 * @param estExterne  initialise la variable estExterne
	 */
	public void setEstExterne(boolean estExterne) {
		this.estExterne = estExterne;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du composant
	 * @return String
	 * @see parcInfo.Composants#toString()
	 */
	public String toString()
	{
		String chaine="Carte reseau" ;
		if(estExterne)
			chaine=chaine+" externe";
		else 
			chaine =chaine+" interne";
		return chaine+"\n"+ super.toString();
	}
}
