/** Classe Abstraite PeripheriquesDivers */
package parcInfo;

abstract public class PeripheriquesDivers extends Composants
{
	private float vitesse;
	private boolean estExterne;
	
	/**
	 * @param nomComposant
	 * @param marqueComposant
	 * @param type
	 * @param vitesse
	 * @param estExterne
	 */
	public PeripheriquesDivers(String nomComposant, String marqueComposant, String type, float vitesse, boolean estExterne) {
		super(nomComposant, marqueComposant, type);
		this.vitesse = vitesse;
		this.estExterne = estExterne;
	}
	
	/**
	 * @return vrai si le peripherique est Externe
	 */
	public boolean isEstExterne() {
		return estExterne;
	}
	
	/**
	 * @param estExterne  initialise la variable estExterne
	 */
	public void setEstExterne(boolean estExterne) {
		this.estExterne = estExterne;
	}
	
	
	/**
	 * @return la vitesse
	 */
	public float getVitesse() {
		return vitesse;
	}
	
	/**
	 * @param vitesse  initialise la variable vitesse
	 */
	public void setVitesse(float vitesse) {
		this.vitesse = vitesse;
	}
	
	/**
	 * Methode permettant d'afficher les caracteristiques
	 * du composant
	 * @return String
	 * @see parcInfo.Composants#toString()
	 */
	public String toString()
	{
		String chaine="";
		
		if (this.estExterne){
			chaine="Composant externe ";
		}
		return chaine+" "+super.toString()+" Vitesse de lecture : " +this.vitesse+"X,";
	}
}
